import{s as Ge,n as Ie,o as Ke}from"../chunks/scheduler.b108d059.js";import{S as We,i as Ue,g as r,s,r as le,A as Oe,h as a,f as t,c as o,j as u,u as de,x as h,k as l,y as d,a as i,v as he,d as ue,t as ce,w as pe}from"../chunks/index.008de539.js";import{I as fe}from"../chunks/IconCopyLink.2c6acad4.js";function Ve(be){let c,I,p,v,j,z,ge,E,ke="Git vs. HTTP-Paradigma",K,H,ze=`Die <code>huggingface_hub</code>-Bibliothek ist eine Bibliothek zur Interaktion mit dem Hugging Face
Hub, einer Sammlung von auf Git basierenden Repositories (Modelle, Datensätze oder
Spaces). Es gibt zwei Hauptmethoden, um auf den Hub mit <code>huggingface_hub</code> zuzugreifen.`,W,_,He=`Der erste Ansatz, der sogenannte “Git-basierte” Ansatz, wird von der <code>Repository</code> Klasse
geleitet. Diese Methode verwendet einen Wrapper um den <code>git</code>-Befehl mit zusätzlichen
Funktionen, die speziell für die Interaktion mit dem Hub entwickelt wurden. Die zweite
Option, die als “HTTP-basierter” Ansatz bezeichnet wird, umfasst das Senden von
HTTP-Anfragen mit dem <code>HfApi</code> Client. Schauen wir uns die Vor- und Nachteile jeder
Methode an.`,U,f,w,B,x,me,R,_e="Repository: Der historische git-basierte Ansatz",O,y,xe=`Ursprünglich wurde <code>huggingface_hub</code> größtenteils um die <code>Repository</code> Klasse herum
entwickelt. Sie bietet Python-Wrapper für gängige git-Befehle wie <code>&quot;git add&quot;</code>, <code>&quot;git commit&quot;</code>,
<code>&quot;git push&quot;</code>, <code>&quot;git tag&quot;</code>, <code>&quot;git checkout&quot;</code> usw.`,V,T,ye=`Die Bibliothek hilft auch beim Festlegen von Zugangsdaten und beim Tracking von großen
Dateien, die in Machine-Learning-Repositories häufig verwendet werden. Darüber hinaus
ermöglicht die Bibliothek das Ausführen ihrer Methoden im Hintergrund, was nützlich ist,
um Daten während des Trainings hochzuladen.`,Z,A,Te=`Der Hauptvorteil bei der Verwendung einer <code>Repository</code> besteht darin, dass Sie eine
lokale Kopie des gesamten Repositorys auf Ihrem Computer pflegen können. Dies kann jedoch
auch ein Nachteil sein, da es erfordert, diese lokale Kopie ständig zu aktualisieren und
zu pflegen. Dies ähnelt der traditionellen Softwareentwicklung, bei der jeder Entwickler
eine eigene lokale Kopie pflegt und Änderungen überträgt, wenn an einer Funktion
gearbeitet wird. Im Kontext des Machine Learning ist dies jedoch nicht immer erforderlich,
da Benutzer möglicherweise nur Gewichte für die Inferenz herunterladen oder Gewichte von
einem Format in ein anderes konvertieren müssen, ohne das gesamte Repository zu klonen.`,J,g,b,F,C,ve,q,Ae="HfApi: Ein flexibler und praktischer HTTP-Client",Q,$,Ce=`Die <code>HfApi</code> Klasse wurde entwickelt, um eine Alternative zu lokalen Git-Repositories
bereitzustellen, die besonders bei der Arbeit mit großen Modellen oder Datensätzen
umständlich zu pflegen sein können. Die <code>HfApi</code> Klasse bietet die gleiche Funktionalität
wie git-basierte Ansätze, wie das Herunterladen und Hochladen von Dateien sowie das
Erstellen von Branches und Tags, jedoch ohne die Notwendigkeit eines lokalen Ordners, der
synchronisiert werden muss.`,X,P,$e=`Zusätzlich zu den bereits von <code>git</code> bereitgestellten Funktionen bietet die <code>HfApi</code>
Klasse zusätzliche Features wie die Möglichkeit, Repositories zu verwalten, Dateien mit
Caching für effiziente Wiederverwendung herunterzuladen, im Hub nach Repositories und
Metadaten zu suchen, auf Community-Funktionen wie Diskussionen, Pull Requests und
Kommentare zuzugreifen und Spaces-Hardware und Geheimnisse zu konfigurieren.`,Y,m,k,G,M,we,N,Pe="Was sollte ich verwenden ? Und wann ?",ee,S,Me=`Insgesamt ist der <strong>HTTP-basierte Ansatz in den meisten Fällen die empfohlene Methode zur Verwendung von</strong> <code>huggingface_hub</code>. Es gibt jedoch einige Situationen, in denen es vorteilhaft sein kann,
eine lokale Git-Kopie (mit <code>Repository</code>) zu pflegen:`,te,D,Se=`<li>Wenn Sie ein Modell auf Ihrem Computer trainieren, kann es effizienter sein, einen
herkömmlichen git-basierten Workflow zu verwenden und regelmäßige Updates zu pushen.
<code>Repository</code> ist für diese Art von Situation mit seiner Fähigkeit zur Hintergrundarbeit optimiert.</li> <li>Wenn Sie große Dateien manuell bearbeiten müssen, ist <code>git</code> die beste Option, da es nur
die Differenz an den Server sendet. Mit dem <code>HfAPI</code> Client wird die gesamte Datei bei
jeder Bearbeitung hochgeladen. Beachten Sie jedoch, dass die meisten großen Dateien binär
sind und daher sowieso nicht von Git-Diffs profitieren.</li>`,ne,L,De=`Nicht alle Git-Befehle sind über <code>HfApi</code> verfügbar. Einige werden vielleicht nie
implementiert, aber wir bemühen uns ständig, die Lücken zu schließen und zu verbessern.
Wenn Sie Ihren Anwendungsfall nicht abgedeckt sehen, öffnen Sie bitte <a href="https://github.com/huggingface/huggingface_hub" rel="nofollow">ein Issue auf
Github</a>! Wir freuen uns über Feedback, um das 🤗-Ökosystem mit und für unsere Benutzer aufzubauen.`,ie;return z=new fe({}),x=new fe({}),C=new fe({}),M=new fe({}),{c(){c=r("meta"),I=s(),p=r("h1"),v=r("a"),j=r("span"),le(z.$$.fragment),ge=s(),E=r("span"),E.textContent=ke,K=s(),H=r("p"),H.innerHTML=ze,W=s(),_=r("p"),_.innerHTML=He,U=s(),f=r("h2"),w=r("a"),B=r("span"),le(x.$$.fragment),me=s(),R=r("span"),R.textContent=_e,O=s(),y=r("p"),y.innerHTML=xe,V=s(),T=r("p"),T.textContent=ye,Z=s(),A=r("p"),A.innerHTML=Te,J=s(),g=r("h2"),b=r("a"),F=r("span"),le(C.$$.fragment),ve=s(),q=r("span"),q.textContent=Ae,Q=s(),$=r("p"),$.innerHTML=Ce,X=s(),P=r("p"),P.innerHTML=$e,Y=s(),m=r("h2"),k=r("a"),G=r("span"),le(M.$$.fragment),we=s(),N=r("span"),N.textContent=Pe,ee=s(),S=r("p"),S.innerHTML=Me,te=s(),D=r("ul"),D.innerHTML=Se,ne=s(),L=r("p"),L.innerHTML=De,this.h()},l(e){const n=Oe("svelte-1phssyn",document.head);c=a(n,"META",{name:!0,content:!0}),n.forEach(t),I=o(e),p=a(e,"H1",{class:!0});var re=u(p);v=a(re,"A",{id:!0,class:!0,href:!0});var Le=u(v);j=a(Le,"SPAN",{});var Ee=u(j);de(z.$$.fragment,Ee),Ee.forEach(t),Le.forEach(t),ge=o(re),E=a(re,"SPAN",{"data-svelte-h":!0}),h(E)!=="svelte-nducgt"&&(E.textContent=ke),re.forEach(t),K=o(e),H=a(e,"P",{"data-svelte-h":!0}),h(H)!=="svelte-kjzwod"&&(H.innerHTML=ze),W=o(e),_=a(e,"P",{"data-svelte-h":!0}),h(_)!=="svelte-hb0so0"&&(_.innerHTML=He),U=o(e),f=a(e,"H2",{class:!0});var ae=u(f);w=a(ae,"A",{id:!0,class:!0,href:!0});var Re=u(w);B=a(Re,"SPAN",{});var qe=u(B);de(x.$$.fragment,qe),qe.forEach(t),Re.forEach(t),me=o(ae),R=a(ae,"SPAN",{"data-svelte-h":!0}),h(R)!=="svelte-jbilb4"&&(R.textContent=_e),ae.forEach(t),O=o(e),y=a(e,"P",{"data-svelte-h":!0}),h(y)!=="svelte-19m9x00"&&(y.innerHTML=xe),V=o(e),T=a(e,"P",{"data-svelte-h":!0}),h(T)!=="svelte-1ujbqa4"&&(T.textContent=ye),Z=o(e),A=a(e,"P",{"data-svelte-h":!0}),h(A)!=="svelte-1k6nrim"&&(A.innerHTML=Te),J=o(e),g=a(e,"H2",{class:!0});var se=u(g);b=a(se,"A",{id:!0,class:!0,href:!0});var Ne=u(b);F=a(Ne,"SPAN",{});var je=u(F);de(C.$$.fragment,je),je.forEach(t),Ne.forEach(t),ve=o(se),q=a(se,"SPAN",{"data-svelte-h":!0}),h(q)!=="svelte-1yawd7h"&&(q.textContent=Ae),se.forEach(t),Q=o(e),$=a(e,"P",{"data-svelte-h":!0}),h($)!=="svelte-cynmrb"&&($.innerHTML=Ce),X=o(e),P=a(e,"P",{"data-svelte-h":!0}),h(P)!=="svelte-1bsqtes"&&(P.innerHTML=$e),Y=o(e),m=a(e,"H2",{class:!0});var oe=u(m);k=a(oe,"A",{id:!0,class:!0,href:!0});var Be=u(k);G=a(Be,"SPAN",{});var Fe=u(G);de(M.$$.fragment,Fe),Fe.forEach(t),Be.forEach(t),we=o(oe),N=a(oe,"SPAN",{"data-svelte-h":!0}),h(N)!=="svelte-2svgz0"&&(N.textContent=Pe),oe.forEach(t),ee=o(e),S=a(e,"P",{"data-svelte-h":!0}),h(S)!=="svelte-1taxrf4"&&(S.innerHTML=Me),te=o(e),D=a(e,"UL",{"data-svelte-h":!0}),h(D)!=="svelte-1dcm1ok"&&(D.innerHTML=Se),ne=o(e),L=a(e,"P",{"data-svelte-h":!0}),h(L)!=="svelte-1mxnr72"&&(L.innerHTML=De),this.h()},h(){l(c,"name","hf:doc:metadata"),l(c,"content",JSON.stringify(Ze)),l(v,"id","git-vs-httpparadigma"),l(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(v,"href","#git-vs-httpparadigma"),l(p,"class","relative group"),l(w,"id","repository-der-historische-gitbasierte-ansatz"),l(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(w,"href","#repository-der-historische-gitbasierte-ansatz"),l(f,"class","relative group"),l(b,"id","hfapi-ein-flexibler-und-praktischer-httpclient"),l(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(b,"href","#hfapi-ein-flexibler-und-praktischer-httpclient"),l(g,"class","relative group"),l(k,"id","was-sollte-ich-verwenden-und-wann"),l(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(k,"href","#was-sollte-ich-verwenden-und-wann"),l(m,"class","relative group")},m(e,n){d(document.head,c),i(e,I,n),i(e,p,n),d(p,v),d(v,j),he(z,j,null),d(p,ge),d(p,E),i(e,K,n),i(e,H,n),i(e,W,n),i(e,_,n),i(e,U,n),i(e,f,n),d(f,w),d(w,B),he(x,B,null),d(f,me),d(f,R),i(e,O,n),i(e,y,n),i(e,V,n),i(e,T,n),i(e,Z,n),i(e,A,n),i(e,J,n),i(e,g,n),d(g,b),d(b,F),he(C,F,null),d(g,ve),d(g,q),i(e,Q,n),i(e,$,n),i(e,X,n),i(e,P,n),i(e,Y,n),i(e,m,n),d(m,k),d(k,G),he(M,G,null),d(m,we),d(m,N),i(e,ee,n),i(e,S,n),i(e,te,n),i(e,D,n),i(e,ne,n),i(e,L,n),ie=!0},p:Ie,i(e){ie||(ue(z.$$.fragment,e),ue(x.$$.fragment,e),ue(C.$$.fragment,e),ue(M.$$.fragment,e),ie=!0)},o(e){ce(z.$$.fragment,e),ce(x.$$.fragment,e),ce(C.$$.fragment,e),ce(M.$$.fragment,e),ie=!1},d(e){e&&(t(I),t(p),t(K),t(H),t(W),t(_),t(U),t(f),t(O),t(y),t(V),t(T),t(Z),t(A),t(J),t(g),t(Q),t($),t(X),t(P),t(Y),t(m),t(ee),t(S),t(te),t(D),t(ne),t(L)),t(c),pe(z),pe(x),pe(C),pe(M)}}}const Ze={local:"git-vs-httpparadigma",sections:[{local:"repository-der-historische-gitbasierte-ansatz",title:"Repository: Der historische git-basierte Ansatz"},{local:"hfapi-ein-flexibler-und-praktischer-httpclient",title:"HfApi: Ein flexibler und praktischer HTTP-Client"},{local:"was-sollte-ich-verwenden-und-wann",title:"Was sollte ich verwenden ? Und wann ?"}],title:"Git vs. HTTP-Paradigma"};function Je(be){return Ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class et extends We{constructor(c){super(),Ue(this,c,Je,Ve,Ge,{})}}export{et as component};
